addHook("PlayerThink", function(player)
	if player.mo.skin == "fisonic"
	    if not (player.mo.hyperform) then
	    player.mo.hyperform = 0
    end
	    if (player.mo.state == S_PLAY_JUMP)
		and (player.cmd.buttons & BT_CUSTOM3)
		and (player.powers[pw_super])
		and (player.rings == 100)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and player.mo.hyperform == 0
		   P_DoSuperTransformation(player, true)
	       player.mo.hyperform = 1
		 end
	 end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.mo and player.mo.skin == "fisonic")
	    and (player.cmd.buttons & BT_CUSTOM3)
		and not (player.powers[pw_carry])
		and (player.mo.state == S_PLAY_JUMP)
		and (player.mo.hyperform == 1)
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_zoom)
		   player.mo.hyperform = 0
		   player.normalspeed = skins["fisonic"].normalspeed
		   player.mindash = skins["fisonic"].mindash
		   player.maxdash = skins["fisonic"].maxdash
		end
	end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.mo and player.mo.skin == "fisonic")
	    and (player.cmd.buttons & BT_CUSTOM3)
		and not (player.powers[pw_carry])
		and (player.mo.state == S_PLAY_JUMP)
		and (player.powers[pw_super])
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_zoom)
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook('ThinkFrame', do
    for player in players.iterate
        if player.mo and player.mo.valid
        and player.mo.skin == "fisonic"
           and (player.mo.hyperform == 1)
	        and player.powers[pw_super]
	        and not (player.pflags & PF_FINISHED)
             player.normalspeed = 60*FRACUNIT
             player.mindash = 60*FRACUNIT
             player.maxdash = 60*FRACUNIT
             player.mo.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
			 player.pflags = $1|PF_INVIS
             local hypertrail = P_SpawnGhostMobj(player.mo)
			 hypertrail.color = player.mo.color
             hypertrail.fuse = 6
			 player.powers[pw_invulnerability] = TICRATE/8
     end 
end
end)


addHook("PlayerThink", function(player)
	if player.mo.skin == "fiknux"
	    if not (player.mo.hyperform) then
	    player.mo.hyperform = 0
    end
	    if (player.mo.state == S_PLAY_JUMP)
		and (player.cmd.buttons & BT_CUSTOM3)
		and (player.powers[pw_super])
		and (player.rings == 100)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and player.mo.hyperform == 0
		   P_DoSuperTransformation(player, true)
	       player.mo.hyperform = 1
		 end
	 end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.mo and player.mo.skin == "fiknux")
	    and (player.cmd.buttons & BT_CUSTOM3)
		and not (player.powers[pw_carry])
		and (player.mo.state == S_PLAY_JUMP)
		and (player.mo.hyperform == 1)
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_zoom)
		   player.mo.hyperform = 0
		   player.normalspeed = skins["fiknux"].normalspeed
		   player.mindash = skins["fiknux"].mindash
		   player.maxdash = skins["fiknux"].maxdash
		end
	end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.mo and player.mo.skin == "fiknux")
	    and (player.cmd.buttons & BT_CUSTOM3)
		and not (player.powers[pw_carry])
		and (player.mo.state == S_PLAY_JUMP)
		and (player.powers[pw_super])
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_zoom)
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook('ThinkFrame', do
    for player in players.iterate
        if player.mo and player.mo.valid
        and player.mo.skin == "fiknux"
           and (player.mo.hyperform == 1)
	        and player.powers[pw_super]
	        and not (player.pflags & PF_FINISHED)
             player.normalspeed = 60*FRACUNIT
             player.mindash = 60*FRACUNIT
             player.maxdash = 60*FRACUNIT
             player.mo.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
			 player.pflags = $1|PF_INVIS
             local hypertrail = P_SpawnGhostMobj(player.mo)
			 hypertrail.color = player.mo.color
             hypertrail.fuse = 6
			 player.powers[pw_invulnerability] = TICRATE/8
     end 
end
end)


addHook("PlayerThink", function(player)
	if player.mo.skin == "fiamy"
	    if not (player.mo.hyperform) then
	    player.mo.hyperform = 0
    end
	    if (player.mo.state == S_PLAY_JUMP)
		and (player.cmd.buttons & BT_CUSTOM3)
		and (player.powers[pw_super])
		and (player.rings == 100)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and player.mo.hyperform == 0
		   P_DoSuperTransformation(player, true)
	       player.mo.hyperform = 1
		 end
	 end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.mo and player.mo.skin == "fiamy")
	    and (player.cmd.buttons & BT_CUSTOM3)
		and not (player.powers[pw_carry])
		and (player.mo.state == S_PLAY_JUMP)
		and (player.mo.hyperform == 1)
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_zoom)
		   player.mo.hyperform = 0
		   player.normalspeed = skins["fiamy"].normalspeed
		end
	end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.mo and player.mo.skin == "fiamy")
	    and (player.cmd.buttons & BT_CUSTOM3)
		and not (player.powers[pw_carry])
		and (player.mo.state == S_PLAY_JUMP)
		and (player.powers[pw_super])
		   player.mo.state = S_PLAY_SUPER_TRANS1
		   S_StartSound(player.mo, sfx_zoom)
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook('ThinkFrame', do
    for player in players.iterate
        if player.mo and player.mo.valid
        and player.mo.skin == "fiamy"
           and (player.mo.hyperform == 1)
	        and player.powers[pw_super]
	        and not (player.pflags & PF_FINISHED)
             player.normalspeed = 60*FRACUNIT
             player.mo.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
			 player.pflags = $1|PF_INVIS
             local hypertrail = P_SpawnGhostMobj(player.mo)
			 hypertrail.color = player.mo.color
             hypertrail.fuse = 6
			 player.powers[pw_invulnerability] = TICRATE/8
     end 
end
end)
